/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #include "game.h"

//implementation of analysis part of the class "Game"

//main analysis function
//Put in analysis database the positions of the main database which satisfy user choice
void Game::analysis_selection() {
	map<string, nimber>::const_iterator SNi;
	Pos_nim PN;
	
	bool pos_ok;            //boolean to indicate whether a position satisfies user's choices
	analysis_base.clear();  //clear base from any previous analysis
	
	for(SNi=main_base.begin(); SNi!=main_base.end(); SNi++) {
		PN.first=fromString(SNi->first);
		PN.second=SNi->second;
		
		//stops when asked by signal
		if (trace_computation.stop_signal()) return;
		
		pos_ok=true;  //suppose first that the position satisfies user's choice
		
		//choice : number of lives
		if (lives_max_analysis) {
			if ( nb_lives(PN.first) > lives_max ) {
				pos_ok=false;
			}
		}
		if (lives_min_analysis) {
			if ( nb_lives(PN.first) < lives_min ) {
				pos_ok=false;
			}
		}
		
		//choice : nimber
		if( nimber_min_analysis && ((SNi->second) < nimber_min) ) {
			pos_ok=false;
		}
		if (nimber_max_analysis && ((SNi->second) > nimber_max) ) {
			pos_ok=false;
		}
		
		//put current position in the analysis database if it satisfies all user's choices
		if(pos_ok) {
			analysis_base[toString(PN.first)]=PN.second;
		}
	}
}
