/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QApplication>
#include "glopwidget.h"

void main_help();
void main_test();
void main_error();
void main_graphic(int argc, char **argv );

int main( int argc, char **argv ) {
	string s;
	switch(argc) {
	  case 2 : s=(string) argv[1];
		if     (s=="-h" || s=="--help")  main_help();
		else if(s=="-t" || s=="--test")  main_test();
		#ifdef MACX
		//special hack for mac platform (there is a program id parameter when run on double-click)
		else if (s.substr(0,4)=="-psn")  main_graphic(argc, argv);
		#endif	
		else                             main_error();
		break;
	  case 1 :
		main_graphic(argc, argv);
		break;
	  default :
		main_error();
	}
	
	return EXIT_SUCCESS;
}

//Qt graphical interface
void main_graphic(int argc, char **argv ) {
	QApplication a( argc, argv );
	GlopWidget *hm = new GlopWidget();
	hm->show();
	a.exec();
}

//available options in command line
void main_help() {
	cout << "Available options for Glop :" << endl << endl
	     << "nothing        :" << "  " << "starts graphical interface" << endl
	     << "-h ou --help   :" << "  " << "prints this help list" << endl
	     << "-t ou --test   :" << "  " << "starts a test function without graphical interface (used for profile)" << endl;
}

//unavailable parameter
void main_error(){
	cout << "This parameter is not valid." << endl
	     << "Use option \"-h\" or \"--help\" to print a list of available parameters." << endl;
}

//Special test option used to realize program profile without thread or graphical interface
void main_test(){
	Game test_game;
  //position to compute
	test_game.parameter.spots_number=11;
  //parameters
	test_game.parameter.computation_kind=global::Main;
	test_game.parameter.use_given_position=false;
  //computation is started "normally" (and not in a separate thread)
	test_game.compute();
  //result
	cout << "base size : " << test_game.main_base.size() << endl;
}
