/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef POSITION_H
#define POSITION_H

#include "land.h"

class Position : public Structure<Land>  {
  public:
	Position(const Line& init) : Structure<Land>(init) {};
	Position() {};
	
	//override terminal_vertex virtual function
	Vertex terminal_vertex();
	
	void cano();                              //canonization
	list<Line> list_lands();                  //list of lands (given by their Line representation)
	void compute_children();                  //children of the position
	char position_type();                     //type of the position (multiple, single, or no land)
	unsigned int estimate_children_number();  //estimates the number of children
};

#endif
