/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "representation.h"

//creation of static members (with default values)
Vertex Representation::free_upper_vtx=0;	//this value has no meaning


//--------------------------------------------------------------------------
//friend fonction to print string simply with << operator
//--------------------------------------------------------------------------
ostream& operator<<(ostream& ostr, const Representation& a) {
	//return on the stream a string corresponding to the vertex list
	return ostr << toString(a.r_vtx);
}


//--------------------------------------------------------------------------
//initializations
//--------------------------------------------------------------------------
Representation::Representation(const Line& init) {
	r_vtx=init; //init parameter is the vertex list
	vertex_is_uptodate=true;
	structure_is_uptodate=false;
}

void Representation::reset(const Line& init) {
	r_vtx=init;
	vertex_is_uptodate=true;
	structure_is_uptodate=false;
}


//--------------------------------------------------------------------------
//definitions of < and == operators to allow STL sort operations
//--------------------------------------------------------------------------
bool Representation::operator<(const Representation& a) const {
	return r_vtx<a.r_vtx;
}

bool Representation::operator==(const Representation& a) const {
	return r_vtx==a.r_vtx;
}
