/***************************************************************************
 *   Copyright (C) 2006 by Julien Lemoine, Simon Viennot                   *
 *   lapinot@tuxfamily.org                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TRACEWIDGET_H
#define TRACEWIDGET_H

#include <QWidget>
#include <QDialog>

#include "trace.h"

class QGridLayout;
class QTableWidget;
class QTableWidgetItem;
class QLineEdit;

class WidgetChildren;

//Widget to trace computing
class WidgetTrace: public QWidget {
	Q_OBJECT
  private:
	Trace* trace;			//link to a trace object
	
  public:
	//main trace widget
	WidgetTrace( QWidget *parent=0, Trace* trace_source=0);
	QTableWidget *table;		//table where positions are displayed
	//widget to print the children of a position
	WidgetChildren *children_popup;
	
  public slots :
	void update_display();		//refresh tracing table

  private slots:
	//function called when the trace table is clicked
	void click_on_position( QTableWidgetItem* item );
};

//Widget to print the children of a position
class WidgetChildren : public QDialog {
	Q_OBJECT
  private:
	Trace* trace;			//link to a trace object
	
  public:
	//initialization of children's trace widget
	WidgetChildren( QWidget *parent=0, Trace* trace_source=0);
	
	//indicates the parent position/nimber
	QLineEdit *parent_position, *nimber_parent;
	QTableWidget *table;		//table where the children are displayed
	QGridLayout *gridLayout;
	bool first_time;		//indicates that children's table has never been created/deleted

	
  public slots :
	void create_table(int);		//create a new table for children
	void delete_table();		//delete children's table
	void update_display();		//refresh displayed children table
	
  private slots:
	//called when the children's table is clicked
	void click_on_children( QTableWidgetItem* item );
};

#endif
